Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 14602)
@@ -47,4 +47,8 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.IO.Compression" />
@@ -63,8 +67,5 @@
   </Choose>
   <ItemGroup>
-    <Compile Include="Benchmark\Example.cs" />
-    <Compile Include="Benchmark\ExampleConverter.cs" />
-    <Compile Include="Benchmark\Problem\CountOdds.cs" />
-    <Compile Include="Benchmark\Problem\Problem.cs" />
+    <Compile Include="Benchmark\ProblemTests.cs" />
     <Compile Include="Interpreter\Expressions\CommonTests.cs" />
     <Compile Include="Interpreter\Expressions\ExampleTests.cs" />
@@ -84,7 +85,12 @@
       <Name>HeuristicLab.Algorithms.PushGP</Name>
     </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="Benchmark\Data\BenchmarkExamples.zip" />
+    <ProjectReference Include="..\HeuristicLab.BenchmarkSuite\HeuristicLab.BenchmarkSuite.csproj">
+      <Project>{22b5c087-cfc7-4d40-86c6-32fcf2ca921e}</Project>
+      <Name>HeuristicLab.BenchmarkSuite</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.ProgramSynthesis\HeuristicLab.Problems.ProgramSynthesis.csproj">
+      <Project>{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}</Project>
+      <Name>HeuristicLab.Problems.ProgramSynthesis</Name>
+    </ProjectReference>
   </ItemGroup>
   <ItemGroup>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user	(revision 14602)
@@ -2,5 +2,5 @@
 <Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
-    <ProjectView>ShowAllFiles</ProjectView>
+    <ProjectView>ProjectFiles</ProjectView>
   </PropertyGroup>
 </Project>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs	(revision 14602)
@@ -32,5 +32,5 @@
     {
       this.interpreter.BooleanStack.Push(true, false);
-      this.interpreter.Interpret(new BooleanAndExpression());
+      this.interpreter.Run(new BooleanAndExpression());
 
       Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
@@ -55,5 +55,5 @@
     {
       this.interpreter.BooleanStack.Push(true, false);
-      this.interpreter.Interpret(new BooleanOrExpression());
+      this.interpreter.Run(new BooleanOrExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -78,5 +78,5 @@
     {
       this.interpreter.BooleanStack.Push(true);
-      this.interpreter.Interpret(new BooleanNotExpression());
+      this.interpreter.Run(new BooleanNotExpression());
 
       Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
@@ -101,5 +101,5 @@
     {
       this.interpreter.FloatStack.Push(2.0);
-      this.interpreter.Interpret(new BooleanFromFloatExpression());
+      this.interpreter.Run(new BooleanFromFloatExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -124,5 +124,5 @@
     {
       this.interpreter.IntegerStack.Push(2);
-      this.interpreter.Interpret(new BooleanFromIntegerExpression());
+      this.interpreter.Run(new BooleanFromIntegerExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 14602)
@@ -35,5 +35,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeAppendExpression());
+      this.interpreter.Run(new CodeAppendExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -51,5 +51,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeAppendExpression());
+      this.interpreter.Run(new CodeAppendExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -67,5 +67,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeAppendExpression());
+      this.interpreter.Run(new CodeAppendExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -82,5 +82,5 @@
 
       this.interpreter.CodeStack.Push(list);
-      this.interpreter.Interpret(new CodeDuplicateExpression());
+      this.interpreter.Run(new CodeDuplicateExpression());
 
       Assert.AreEqual(this.Stack.Count, 2);
@@ -99,5 +99,5 @@
 
       this.interpreter.CodeStack.Push(first);
-      this.interpreter.Interpret(new CodeAtomExpression());
+      this.interpreter.Run(new CodeAtomExpression());
 
       Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
@@ -113,5 +113,5 @@
 
       this.interpreter.CodeStack.Push(first);
-      this.interpreter.Interpret(new CodeAtomExpression());
+      this.interpreter.Run(new CodeAtomExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -127,5 +127,5 @@
 
       this.interpreter.CodeStack.Push(first);
-      this.interpreter.Interpret(new CodeAtomExpression());
+      this.interpreter.Run(new CodeAtomExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -142,5 +142,5 @@
 
       this.interpreter.CodeStack.Push(first);
-      this.interpreter.Interpret(new CodeCarExpression());
+      this.interpreter.Run(new CodeCarExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -157,5 +157,5 @@
 
       this.interpreter.CodeStack.Push(first);
-      this.interpreter.Interpret(new CodeCarExpression());
+      this.interpreter.Run(new CodeCarExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -172,5 +172,5 @@
 
       this.interpreter.CodeStack.Push(first);
-      this.interpreter.Interpret(new CodeCdrExpression());
+      this.interpreter.Run(new CodeCdrExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -187,5 +187,5 @@
 
       this.interpreter.CodeStack.Push(first);
-      this.interpreter.Interpret(new CodeCdrExpression());
+      this.interpreter.Run(new CodeCdrExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -203,5 +203,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeConsExpression());
+      this.interpreter.Run(new CodeConsExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -218,5 +218,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeContainsExpression());
+      this.interpreter.Run(new CodeContainsExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -233,5 +233,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeContainsExpression());
+      this.interpreter.Run(new CodeContainsExpression());
 
       Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
@@ -249,5 +249,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeContainerExpression());
+      this.interpreter.Run(new CodeContainerExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -265,5 +265,5 @@
       this.interpreter.NameStack.Push("Test");
 
-      this.interpreter.Interpret(new CodeDefinitionExpression());
+      this.interpreter.Run(new CodeDefinitionExpression());
 
       Assert.AreEqual(code, this.interpreter.CodeStack.Top);
@@ -281,5 +281,5 @@
       this.interpreter.CustomExpressions.Add("Test1", code);
       this.interpreter.NameStack.Push("Test2");
-      this.interpreter.Interpret(program);
+      this.interpreter.Run(program);
 
       this.TestStackCounts(nameStack: 1);
@@ -295,5 +295,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeDiscrepancyExpression());
+      this.interpreter.Run(new CodeDiscrepancyExpression());
 
       Assert.AreEqual(2, this.interpreter.IntegerStack.Top);
@@ -310,5 +310,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeDiscrepancyExpression());
+      this.interpreter.Run(new CodeDiscrepancyExpression());
 
       Assert.AreEqual(0, this.interpreter.IntegerStack.Top);
@@ -325,5 +325,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeDiscrepancyExpression());
+      this.interpreter.Run(new CodeDiscrepancyExpression());
 
       Assert.AreEqual(3, this.interpreter.IntegerStack.Top);
@@ -340,5 +340,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeDiscrepancyExpression());
+      this.interpreter.Run(new CodeDiscrepancyExpression());
 
       Assert.AreEqual(5, this.interpreter.IntegerStack.Top);
@@ -354,5 +354,5 @@
 
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeDoExpression());
+      this.interpreter.Run(new CodeDoExpression());
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -368,5 +368,5 @@
 
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeDoXExpression());
+      this.interpreter.Run(new CodeDoXExpression());
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -383,5 +383,5 @@
       this.interpreter.IntegerStack.Push(3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeDoCountExpression());
+      this.interpreter.Run(new CodeDoCountExpression());
 
       Assert.AreEqual(6, this.interpreter.IntegerStack.Top);
@@ -398,5 +398,5 @@
       this.interpreter.IntegerStack.Push(-1);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeDoCountExpression());
+      this.interpreter.Run(new CodeDoCountExpression());
 
       Assert.AreEqual(-1, this.interpreter.IntegerStack.Top);
@@ -413,5 +413,5 @@
       this.interpreter.IntegerStack.Push(3, 5);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeDoRangeExpression());
+      this.interpreter.Run(new CodeDoRangeExpression());
 
       Assert.AreEqual(12, this.interpreter.IntegerStack.Top);
@@ -428,5 +428,5 @@
       this.interpreter.IntegerStack.Push(3, 3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeDoRangeExpression());
+      this.interpreter.Run(new CodeDoRangeExpression());
 
       Assert.AreEqual(3, this.interpreter.IntegerStack.Top);
@@ -443,5 +443,5 @@
       this.interpreter.IntegerStack.Push(-3, -5);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeDoRangeExpression());
+      this.interpreter.Run(new CodeDoRangeExpression());
 
       Assert.AreEqual(-12, this.interpreter.IntegerStack.Top);
@@ -458,5 +458,5 @@
       this.interpreter.IntegerStack.Push(2, 3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeDoTimesExpression());
+      this.interpreter.Run(new CodeDoTimesExpression());
 
       Assert.AreEqual(32, this.interpreter.IntegerStack.Top);
@@ -473,5 +473,5 @@
       this.interpreter.IntegerStack.Push(2, -3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeDoTimesExpression());
+      this.interpreter.Run(new CodeDoTimesExpression());
 
       Assert.AreEqual(-3, this.interpreter.IntegerStack.Top);
@@ -484,5 +484,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNestedDoRange() {
-      this.interpreter.Interpret(
+      this.interpreter.Run(
         "( 0 2 CODE.QUOTE ( 1 INTEGER.+ 0 3 CODE.QUOTE ( 1 INTEGER.+ INTEGER.* ) CODE.DO*RANGE INTEGER.+ ) CODE.DO*RANGE )");
 
@@ -496,5 +496,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNestedDoCount() {
-      this.interpreter.Interpret(
+      this.interpreter.Run(
         "( 2 CODE.QUOTE ( 1 INTEGER.+ 3 CODE.QUOTE ( 1 INTEGER.+ INTEGER.* ) CODE.DO*COUNT INTEGER.+ ) CODE.DO*COUNT )");
 
@@ -508,5 +508,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNestedDoTimes() {
-      this.interpreter.Interpret(
+      this.interpreter.Run(
         "( 3 CODE.QUOTE ( 2 3 CODE.QUOTE ( 2 INTEGER.* ) CODE.DO*TIMES INTEGER.+ ) CODE.DO*TIMES )");
 
@@ -525,5 +525,5 @@
       this.interpreter.IntegerStack.Push(5);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeExtractExpression());
+      this.interpreter.Run(new CodeExtractExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -541,5 +541,5 @@
       this.interpreter.IntegerStack.Push(3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeExtractExpression());
+      this.interpreter.Run(new CodeExtractExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -557,5 +557,5 @@
       this.interpreter.IntegerStack.Push(6);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeExtractExpression());
+      this.interpreter.Run(new CodeExtractExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -573,5 +573,5 @@
       this.interpreter.IntegerStack.Push(8);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeExtractExpression());
+      this.interpreter.Run(new CodeExtractExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -589,5 +589,5 @@
       this.interpreter.IntegerStack.Push(7);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeExtractExpression());
+      this.interpreter.Run(new CodeExtractExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -602,5 +602,5 @@
       var result = PushGPParser.Parse("FALSE");
       this.interpreter.BooleanStack.Push(false);
-      this.interpreter.Interpret(new CodeFromBooleanExpression());
+      this.interpreter.Run(new CodeFromBooleanExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -615,5 +615,5 @@
       var result = PushGPParser.Parse("4.1");
       this.interpreter.FloatStack.Push(4.1);
-      this.interpreter.Interpret(new CodeFromFloatExpression());
+      this.interpreter.Run(new CodeFromFloatExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -628,5 +628,5 @@
       var result = PushGPParser.Parse("4");
       this.interpreter.IntegerStack.Push(4);
-      this.interpreter.Interpret(new CodeFromIntegerExpression());
+      this.interpreter.Run(new CodeFromIntegerExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -641,5 +641,5 @@
       var result = PushGPParser.Parse("A");
       this.interpreter.NameStack.Push("A");
-      this.interpreter.Interpret(new CodeFromNameExpression());
+      this.interpreter.Run(new CodeFromNameExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -657,5 +657,5 @@
       this.interpreter.BooleanStack.Push(true);
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeIfExpression());
+      this.interpreter.Run(new CodeIfExpression());
 
       Assert.AreEqual("WAHR", this.interpreter.NameStack.Top);
@@ -673,5 +673,5 @@
       this.interpreter.BooleanStack.Push(false);
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeIfExpression());
+      this.interpreter.Run(new CodeIfExpression());
 
       Assert.AreEqual("FALSCH", this.interpreter.NameStack.Top);
@@ -690,5 +690,5 @@
       this.interpreter.IntegerStack.Push(2);
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeInsertExpression());
+      this.interpreter.Run(new CodeInsertExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -707,5 +707,5 @@
       this.interpreter.IntegerStack.Push(-2);
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeInsertExpression());
+      this.interpreter.Run(new CodeInsertExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -724,5 +724,5 @@
       this.interpreter.IntegerStack.Push(10);
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeInsertExpression());
+      this.interpreter.Run(new CodeInsertExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -740,5 +740,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeListExpression());
+      this.interpreter.Run(new CodeListExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -755,5 +755,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeMemberExpression());
+      this.interpreter.Run(new CodeMemberExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -770,5 +770,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeMemberExpression());
+      this.interpreter.Run(new CodeMemberExpression());
 
       Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
@@ -785,5 +785,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodeMemberExpression());
+      this.interpreter.Run(new CodeMemberExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -796,5 +796,5 @@
     [TestCategory("CodeExpressionTest")]
     public void TestNoop() {
-      this.interpreter.Interpret(new CodeNoopExpression());
+      this.interpreter.Run(new CodeNoopExpression());
 
       this.CheckOtherStacksAreEmpty();
@@ -811,5 +811,5 @@
       this.interpreter.IntegerStack.Push(3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthExpression());
+      this.interpreter.Run(new CodeNthExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -827,5 +827,5 @@
       this.interpreter.IntegerStack.Push(3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthExpression());
+      this.interpreter.Run(new CodeNthExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -843,5 +843,5 @@
       this.interpreter.IntegerStack.Push(3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthExpression());
+      this.interpreter.Run(new CodeNthExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -859,5 +859,5 @@
       this.interpreter.IntegerStack.Push(13);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthExpression());
+      this.interpreter.Run(new CodeNthExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -875,5 +875,5 @@
       this.interpreter.IntegerStack.Push(-3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthExpression());
+      this.interpreter.Run(new CodeNthExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -891,5 +891,5 @@
       this.interpreter.IntegerStack.Push(2);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthCdrExpression());
+      this.interpreter.Run(new CodeNthCdrExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -907,5 +907,5 @@
       this.interpreter.IntegerStack.Push(10);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthCdrExpression());
+      this.interpreter.Run(new CodeNthCdrExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -923,5 +923,5 @@
       this.interpreter.IntegerStack.Push(-2);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthCdrExpression());
+      this.interpreter.Run(new CodeNthCdrExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -939,5 +939,5 @@
       this.interpreter.IntegerStack.Push(3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthCdrExpression());
+      this.interpreter.Run(new CodeNthCdrExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -955,5 +955,5 @@
       this.interpreter.IntegerStack.Push(3);
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNthCdrExpression());
+      this.interpreter.Run(new CodeNthCdrExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -969,5 +969,5 @@
 
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNullExpression());
+      this.interpreter.Run(new CodeNullExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -983,5 +983,5 @@
 
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeNullExpression());
+      this.interpreter.Run(new CodeNullExpression());
 
       Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
@@ -998,5 +998,5 @@
 
       this.interpreter.CodeStack.Push(second, first);
-      this.interpreter.Interpret(new CodePositionExpression());
+      this.interpreter.Run(new CodePositionExpression());
 
       Assert.AreEqual(2, this.interpreter.IntegerStack.Top);
@@ -1011,5 +1011,5 @@
       var result = PushGPParser.Parse("A");
 
-      this.interpreter.Interpret("( CODE.QUOTE A )");
+      this.interpreter.Run("( CODE.QUOTE A )");
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
@@ -1025,5 +1025,5 @@
 
       this.interpreter.CodeStack.Push(prog);
-      this.interpreter.Interpret(new CodeSizeExpression());
+      this.interpreter.Run(new CodeSizeExpression());
 
       Assert.AreEqual(4, this.interpreter.IntegerStack.Top);
@@ -1042,5 +1042,5 @@
 
       this.interpreter.CodeStack.Push(third, second, first);
-      this.interpreter.Interpret(new CodeSubstitutionExpression());
+      this.interpreter.Run(new CodeSubstitutionExpression());
 
       Assert.AreEqual(result, this.interpreter.CodeStack.Top);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs	(revision 14602)
@@ -19,5 +19,5 @@
 
     protected virtual void Test(Expression expression) {
-      this.interpreter.Interpret(expression);
+      this.interpreter.Run(expression);
     }
 
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 14602)
@@ -12,5 +12,5 @@
     [TestCategory("ExampleTest")]
     public void Example1() {
-      this.interpreter.Interpret("( 2 3 INTEGER.* 4.1 5.2 FLOAT.+ TRUE FALSE BOOLEAN.OR )");
+      this.interpreter.Run("( 2 3 INTEGER.* 4.1 5.2 FLOAT.+ TRUE FALSE BOOLEAN.OR )");
 
       Assert.AreEqual(6, this.interpreter.IntegerStack.Top);
@@ -26,5 +26,5 @@
     [TestCategory("ExampleTest")]
     public void Example2() {
-      this.interpreter.Interpret("( 5 1.23 INTEGER.+ ( 4 ) INTEGER.- 5.67 FLOAT.* )");
+      this.interpreter.Run("( 5 1.23 INTEGER.+ ( 4 ) INTEGER.- 5.67 FLOAT.* )");
 
       Assert.AreEqual(1, this.interpreter.IntegerStack.Top);
@@ -40,5 +40,5 @@
     [TestCategory("ExampleTest")]
     public void Example3() {
-      this.interpreter.Interpret("( 5 INTEGER.DUP INTEGER.+ )");
+      this.interpreter.Run("( 5 INTEGER.DUP INTEGER.+ )");
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -54,5 +54,5 @@
     [TestCategory("ExampleTest")]
     public void Example4() {
-      this.interpreter.Interpret("( 5 CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DO )");
+      this.interpreter.Run("( 5 CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DO )");
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -68,5 +68,5 @@
     [TestCategory("ExampleTest")]
     public void Example5() {
-      this.interpreter.Interpret("( DOUBLE CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DEFINE 5 DOUBLE )");
+      this.interpreter.Run("( DOUBLE CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) CODE.DEFINE 5 DOUBLE )");
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -82,5 +82,5 @@
     [TestCategory("ExampleTest")]
     public void Example6() {
-      this.interpreter.Interpret("( CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) DOUBLE CODE.DEFINE 5 DOUBLE )");
+      this.interpreter.Run("( CODE.QUOTE ( INTEGER.DUP INTEGER.+ ) DOUBLE CODE.DEFINE 5 DOUBLE )");
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -96,5 +96,5 @@
     [TestCategory("ExampleTest")]
     public void Example7() {
-      this.interpreter.Interpret("( DOUBLE EXEC.DEFINE ( INTEGER.DUP INTEGER.+ ) 5 DOUBLE )");
+      this.interpreter.Run("( DOUBLE EXEC.DEFINE ( INTEGER.DUP INTEGER.+ ) 5 DOUBLE )");
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -113,5 +113,5 @@
 
       this.interpreter.IntegerStack.Push(5);
-      this.interpreter.Interpret(@"( CODE.QUOTE ( INTEGER.POP 1 )
+      this.interpreter.Run(@"( CODE.QUOTE ( INTEGER.POP 1 )
                                            CODE.QUOTE ( CODE.DUP INTEGER.DUP 1 INTEGER.- CODE.DO INTEGER.* )
                                            INTEGER.DUP 2 INTEGER.< CODE.IF )");
@@ -130,5 +130,5 @@
     public void Example9() {
       this.interpreter.IntegerStack.Push(5);
-      this.interpreter.Interpret("( 1 INTEGER.MAX 1 EXEC.DO*RANGE INTEGER.* )");
+      this.interpreter.Run("( 1 INTEGER.MAX 1 EXEC.DO*RANGE INTEGER.* )");
 
       Assert.AreEqual(120, this.interpreter.IntegerStack.Top);
@@ -145,5 +145,5 @@
     public void Example10() {
       this.interpreter.IntegerStack.Push(5);
-      this.interpreter.Interpret("( 1 INTEGER.MAX 1 EXEC.DO*RANGE ( 2 INTEGER.* ) )");
+      this.interpreter.Run("( 1 INTEGER.MAX 1 EXEC.DO*RANGE ( 2 INTEGER.* ) )");
 
       Assert.AreEqual(2, this.interpreter.IntegerStack.Top);
@@ -164,5 +164,5 @@
       this.interpreter.FloatStack.Push(2.1, 0.7);
 
-      this.interpreter.Interpret(program);
+      this.interpreter.Run(program);
 
       Assert.IsTrue(this.interpreter.IntegerStack.IsEmpty);
@@ -176,5 +176,5 @@
       this.interpreter.IntegerStack.Push(1, 2);
       this.interpreter.FloatStack.Push(2.1, 0.7);
-      this.interpreter.Interpret(program);
+      this.interpreter.Run(program);
 
       Assert.IsTrue(this.interpreter.IntegerStack.IsEmpty);
@@ -195,5 +195,5 @@
       this.interpreter.FloatStack.Push(2.1, 0.7);
 
-      this.interpreter.Interpret(program);
+      this.interpreter.Run(program);
 
       Assert.IsTrue(this.interpreter.IntegerStack.IsEmpty);
@@ -207,5 +207,5 @@
       this.interpreter.IntegerStack.Push(1, 2);
       this.interpreter.FloatStack.Push(2.1, 0.7);
-      this.interpreter.Interpret(program);
+      this.interpreter.Run(program);
 
       Assert.IsTrue(this.interpreter.IntegerStack.IsEmpty);
@@ -222,5 +222,5 @@
     public void Example13() {
       this.interpreter.IntegerStack.Push(5);
-      this.interpreter.Interpret("( EXEC.Y ( ( FALSE 2 INTEGER.* ) EXEC.IF ( ) EXEC.POP ) )");
+      this.interpreter.Run("( EXEC.Y ( ( FALSE 2 INTEGER.* ) EXEC.IF ( ) EXEC.POP ) )");
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -237,5 +237,5 @@
     public void Example14() {
       this.interpreter.IntegerStack.Push(5);
-      this.interpreter.Interpret("( EXEC.Y ( ( 2 INTEGER.* INTEGER.DUP 1000 INTEGER.< ) EXEC.IF ( ) EXEC.POP ) )");
+      this.interpreter.Run("( EXEC.Y ( ( 2 INTEGER.* INTEGER.DUP 1000 INTEGER.< ) EXEC.IF ( ) EXEC.POP ) )");
 
       Assert.AreEqual(1280, this.interpreter.IntegerStack.Top);
@@ -253,12 +253,12 @@
       this.interpreter.IntegerStack.Push(10);
       this.interpreter.FloatStack.Push(2);
-      this.interpreter.Interpret(@"( ARG FLOAT.DEFINE
-                                           EXEC.Y (
-                                           ARG FLOAT.*
-                                           1 INTEGER.-
-                                           INTEGER.DUP 1 INTEGER.>
-                                           EXEC.IF ( ) EXEC.POP
-                                           )
-                                         )");
+      this.interpreter.Run(@"( ARG FLOAT.DEFINE
+                                     EXEC.Y (
+                                       ARG FLOAT.*
+                                       1 INTEGER.-
+                                       INTEGER.DUP 1 INTEGER.>
+                                       EXEC.IF ( ) EXEC.POP
+                                     )
+                                   )");
 
       Assert.AreEqual(1024, this.interpreter.FloatStack.Top, Delta);
@@ -277,5 +277,5 @@
 
       this.interpreter.CodeStack.Push(list);
-      this.interpreter.Interpret("( CODE.DUP 0 CODE.INSERT )");
+      this.interpreter.Run("( CODE.DUP 0 CODE.INSERT )");
 
       var id = this.interpreter.CodeStack.Top.GetHashCode();
